searchNodes=[{"ref":"Wallaby.html","title":"Wallaby","type":"module","doc":"A concurrent feature testing library. Configuration Wallaby supports the following options: :pool_size - Maximum amount of phantoms to run. The default is :erlang.system_info(:schedulers_online) * 2. :screenshot_dir - The directory to store screenshots. :screenshot_on_failure - if Wallaby should take screenshots on test failures (defaults to false). :max_wait_time - The amount of time that Wallaby should wait to find an element on the page. (defaults to 3_000) :js_errors - if Wallaby should re-throw javascript errors in elixir (defaults to true). :js_logger - IO device where javascript console logs are written to. Defaults to :stdio. This option can also be set to a file or any other io device. You can disable javascript console logging by setting this to nil. :phantomjs - The path to the phantomjs executable (defaults to &quot;phantomjs&quot;) :phantomjs_args - Any extra arguments that should be passed to phantomjs (defaults to &quot;&quot;)"},{"ref":"Wallaby.html#driver/0","title":"Wallaby.driver/0","type":"function","doc":""},{"ref":"Wallaby.html#end_session/1","title":"Wallaby.end_session/1","type":"function","doc":"Ends a browser session."},{"ref":"Wallaby.html#start_session/1","title":"Wallaby.start_session/1","type":"function","doc":"Starts a browser session. Multiple sessions Each session runs in its own browser so that each test runs in isolation. Because of this isolation multiple sessions can be created for a test: @message_field Query.text_field(&quot;Share Message&quot;) @share_button Query.button(&quot;Share&quot;) @message_list Query.css(&quot;.messages&quot;) test &quot;That multiple sessions work&quot; do {:ok, user1} = Wallaby.start_session user1 |&gt; visit(&quot;/page.html&quot;) |&gt; fill_in(@message_field, with: &quot;Hello there!&quot;) |&gt; click(@share_button) {:ok, user2} = Wallaby.start_session user2 |&gt; visit(&quot;/page.html&quot;) |&gt; fill_in(@message_field, with: &quot;Hello yourself&quot;) |&gt; click(@share_button) assert user1 |&gt; find(@message_list) |&gt; List.last |&gt; text == &quot;Hello yourself&quot; assert user2 |&gt; find(@message_list) |&gt; List.first |&gt; text == &quot;Hello there&quot; end"},{"ref":"Wallaby.html#t:reason/0","title":"Wallaby.reason/0","type":"type","doc":""},{"ref":"Wallaby.html#t:start_session_opts/0","title":"Wallaby.start_session_opts/0","type":"type","doc":""},{"ref":"Wallaby.BadMetadataError.html","title":"Wallaby.BadMetadataError","type":"exception","doc":""},{"ref":"Wallaby.Browser.html","title":"Wallaby.Browser","type":"module","doc":"The Browser module is the entrypoint for interacting with a real browser. By default, action only work with elements that are visible to a real user. Actions Actions are used to interact with form elements. All actions work with the query interface: &lt;label for=&quot;first_name&quot;&gt; First Name &lt;/label&gt; &lt;input id=&quot;user_first_name&quot; type=&quot;text&quot; name=&quot;first_name&quot;&gt; fill_in(page, Query.text_field(&quot;First Name&quot;), with: &quot;Grace&quot;) fill_in(page, Query.text_field(&quot;first_name&quot;), with: &quot;Grace&quot;) fill_in(page, Query.text_field(&quot;user_first_name&quot;), with: &quot;Grace&quot;) These queries work with any of the available actions. fill_in(page, Query.text_field(&quot;First Name&quot;), with: &quot;Chris&quot;) clear(page, Query.text_field(&quot;user_email&quot;)) click(page, Query.radio_button(&quot;Radio Button 1&quot;)) click(page, Query.checkbox(&quot;Checkbox&quot;)) click(page, Query.checkbox(&quot;Checkbox&quot;)) click(page, Query.option(&quot;Option 1&quot;)) click(page, Query.button(&quot;Some Button&quot;)) attach_file(page, Query.file_field(&quot;Avatar&quot;), path: &quot;test/fixtures/avatar.jpg&quot;) Actions return their parent element so that they can be chained together: page |&gt; find(Query.css(&quot;.signup-form&quot;), fn(form) -&gt; form |&gt; fill_in(Query.text_field(&quot;Name&quot;), with: &quot;Grace Hopper&quot;) |&gt; fill_in(Query.text_field(&quot;Email&quot;), with: &quot;grace@hopper.com&quot;) |&gt; click(Query.button(&quot;Submit&quot;)) end) Scoping Finders provide scoping like so: session |&gt; visit(&quot;/page.html&quot;) |&gt; find(Query.css(&quot;.users&quot;)) |&gt; find(Query.css(&quot;.user&quot;, count: 3)) |&gt; List.first |&gt; find(Query.css(&quot;.user-name&quot;)) If a callback is passed to find then the scoping will only apply to the callback and the parent will be passed to the next action in the chain: page |&gt; find(Query.css(&quot;.todo-form&quot;), fn(form) -&gt; form |&gt; fill_in(Query.text_field(&quot;What needs doing?&quot;), with: &quot;Write Wallaby Documentation&quot;) |&gt; click(Query.button(&quot;Save&quot;)) end) |&gt; find(Query.css(&quot;.success-notification&quot;), fn(notification) -&gt; assert notification |&gt; has_text?(&quot;Todo created successfully!&quot;) end) This allows you to create a test that is logically grouped together in a single pipeline. It also means that its easy to create re-usable helper functions without having to worry about chaining. You could re-write the above example like this: def create_todo(page, todo) do find(Query.css(&quot;.todo-form&quot;), &amp; fill_in_and_save_todo(&amp;1, todo)) end def fill_in_and_save_todo(form, todo) do form |&gt; fill_in(Query.text_field(&quot;What needs doing?&quot;), with: todo) |&gt; click(Query.button(&quot;Save&quot;)) end def todo_was_created?(page) do find Query.css(page, &quot;.success-notification&quot;), fn(notification) -&gt; assert notification |&gt; has_text?(&quot;Todo created successfully!&quot;) end end assert page |&gt; create_todo(&quot;Write Wallaby Documentation&quot;) |&gt; todo_was_created?"},{"ref":"Wallaby.Browser.html#accept_alert/2","title":"Wallaby.Browser.accept_alert/2","type":"function","doc":"Accepts one alert dialog, which must be triggered within the specified fun. Returns the message that was presented to the user. For example: message = accept_alert session, fn(s) -&gt; click(s, Query.link(&quot;Trigger alert&quot;)) end"},{"ref":"Wallaby.Browser.html#accept_confirm/2","title":"Wallaby.Browser.accept_confirm/2","type":"function","doc":"Accepts one confirmation dialog, which must be triggered within the specified fun. Returns the message that was presented to the user. For example: message = accept_confirm session, fn(s) -&gt; click(s, Query.link(&quot;Trigger confirm&quot;)) end"},{"ref":"Wallaby.Browser.html#accept_prompt/2","title":"Wallaby.Browser.accept_prompt/2","type":"function","doc":"Accepts one prompt, which must be triggered within the specified fun. The [with: value] option allows to simulate user input for the prompt. If no value is provided, the default value that was passed to window.prompt will be used instead. Returns the message that was presented to the user. For example: message = accept_prompt session, fn(s) -&gt; click(s, Query.link(&quot;Trigger prompt&quot;)) end Example providing user input: message = accept_prompt session, [with: &quot;User input&quot;], fn(s) -&gt; click(s, Query.link(&quot;Trigger prompt&quot;)) end"},{"ref":"Wallaby.Browser.html#accept_prompt/3","title":"Wallaby.Browser.accept_prompt/3","type":"function","doc":""},{"ref":"Wallaby.Browser.html#all/2","title":"Wallaby.Browser.all/2","type":"function","doc":"Finds all of the DOM elements that match the css selector. If no elements are found then an empty list is immediately returned. This is equivalent to calling find(session, css(&quot;element&quot;, count: nil, minimum: 0))."},{"ref":"Wallaby.Browser.html#assert_has/2","title":"Wallaby.Browser.assert_has/2","type":"macro","doc":"Checks if query is present within parent and raises if not found. Returns the given parent if the assertion is correct so that it is easily pipeable. Examples session |&gt; visit(&quot;/&quot;) |&gt; assert_has(Query.css(&quot;.login-button&quot;))"},{"ref":"Wallaby.Browser.html#assert_text/2","title":"Wallaby.Browser.assert_text/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#assert_text/3","title":"Wallaby.Browser.assert_text/3","type":"function","doc":"Matches the Element&#39;s content with the provided text and raises if not found"},{"ref":"Wallaby.Browser.html#attach_file/3","title":"Wallaby.Browser.attach_file/3","type":"function","doc":"Attaches a file to a file input. Input elements are looked up by id, label text, or name."},{"ref":"Wallaby.Browser.html#attr/3","title":"Wallaby.Browser.attr/3","type":"function","doc":"Gets the value of the elements attribute."},{"ref":"Wallaby.Browser.html#button_down/2","title":"Wallaby.Browser.button_down/2","type":"function","doc":"Clicks and holds the given mouse button at the current mouse coordinates."},{"ref":"Wallaby.Browser.html#button_up/2","title":"Wallaby.Browser.button_up/2","type":"function","doc":"Releases given previously held mouse button."},{"ref":"Wallaby.Browser.html#clear/2","title":"Wallaby.Browser.clear/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#click/2","title":"Wallaby.Browser.click/2","type":"function","doc":"Clicks an element."},{"ref":"Wallaby.Browser.html#close_window/1","title":"Wallaby.Browser.close_window/1","type":"function","doc":"Closes the currently focused window."},{"ref":"Wallaby.Browser.html#cookies/1","title":"Wallaby.Browser.cookies/1","type":"function","doc":""},{"ref":"Wallaby.Browser.html#current_path/1","title":"Wallaby.Browser.current_path/1","type":"function","doc":"Gets the current path of the session"},{"ref":"Wallaby.Browser.html#current_url/1","title":"Wallaby.Browser.current_url/1","type":"function","doc":"Gets the current url of the session"},{"ref":"Wallaby.Browser.html#dismiss_confirm/2","title":"Wallaby.Browser.dismiss_confirm/2","type":"function","doc":"Dismisses one confirmation dialog, which must be triggered within the specified fun. Returns the message that was presented to the user. For example: message = dismiss_confirm session, fn(s) -&gt; click(s, Query.link(&quot;Trigger confirm&quot;)) end"},{"ref":"Wallaby.Browser.html#dismiss_prompt/2","title":"Wallaby.Browser.dismiss_prompt/2","type":"function","doc":"Dismisses one prompt, which must be triggered within the specified fun. Returns the message that was presented to the user. For example: message = dismiss_prompt session, fn(s) -&gt; click(s, Query.link(&quot;Trigger prompt&quot;)) end"},{"ref":"Wallaby.Browser.html#double_click/1","title":"Wallaby.Browser.double_click/1","type":"function","doc":"Double-clicks left mouse button at the current mouse coordinates."},{"ref":"Wallaby.Browser.html#execute_query/2","title":"Wallaby.Browser.execute_query/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#execute_script/2","title":"Wallaby.Browser.execute_script/2","type":"function","doc":"Executes javascript synchronously, taking as arguments the script to execute, an optional list of arguments available in the script via arguments, and an optional callback function with the result of script execution as a parameter."},{"ref":"Wallaby.Browser.html#execute_script/3","title":"Wallaby.Browser.execute_script/3","type":"function","doc":""},{"ref":"Wallaby.Browser.html#execute_script/4","title":"Wallaby.Browser.execute_script/4","type":"function","doc":""},{"ref":"Wallaby.Browser.html#execute_script_async/2","title":"Wallaby.Browser.execute_script_async/2","type":"function","doc":"Executes asynchronous javascript, taking as arguments the script to execute, an optional list of arguments available in the script via arguments, and an optional callback function with the result of script execution as a parameter."},{"ref":"Wallaby.Browser.html#execute_script_async/3","title":"Wallaby.Browser.execute_script_async/3","type":"function","doc":""},{"ref":"Wallaby.Browser.html#execute_script_async/4","title":"Wallaby.Browser.execute_script_async/4","type":"function","doc":""},{"ref":"Wallaby.Browser.html#fill_in/3","title":"Wallaby.Browser.fill_in/3","type":"function","doc":"Fills in an element identified by query with value. All inputs previously present in the input field will be overridden. Examples page |&gt; fill_in(Query.text_field(&quot;name&quot;), with: &quot;Chris&quot;) |&gt; fill_in(Query.css(&quot;#password_field&quot;, with: &quot;secret42&quot;)) Note Currently, ChromeDriver only supports BMP Unicode characters. Emojis are SMP characters and will be ignored by ChromeDriver. Using JavaScript is a known workaround for filling in fields with Emojis and other non-BMP characters."},{"ref":"Wallaby.Browser.html#find/2","title":"Wallaby.Browser.find/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#find/3","title":"Wallaby.Browser.find/3","type":"function","doc":"Finds a specific DOM element on the page based on a css selector. Blocks until it either finds the element or until the max time is reached. By default only 1 element is expected to match the query. If more elements are present then a count can be specified. Use :any to allow any number of elements to be present. By default only elements that are visible on the page are returned. Selections can be scoped by providing a Element as the locator for the query. By default finders only work with elements that would be visible to a real user."},{"ref":"Wallaby.Browser.html#focus_default_frame/1","title":"Wallaby.Browser.focus_default_frame/1","type":"function","doc":"Changes the driver focus to the default (top level) frame."},{"ref":"Wallaby.Browser.html#focus_frame/2","title":"Wallaby.Browser.focus_frame/2","type":"function","doc":"Changes the driver focus to the frame found by query."},{"ref":"Wallaby.Browser.html#focus_parent_frame/1","title":"Wallaby.Browser.focus_parent_frame/1","type":"function","doc":"Changes the driver focus to the parent frame."},{"ref":"Wallaby.Browser.html#focus_window/2","title":"Wallaby.Browser.focus_window/2","type":"function","doc":"Changes the driver focus to the window identified by the handle."},{"ref":"Wallaby.Browser.html#has?/2","title":"Wallaby.Browser.has?/2","type":"function","doc":"Validates that the query returns a result. This can be used to define other types of matchers."},{"ref":"Wallaby.Browser.html#has_css?/2","title":"Wallaby.Browser.has_css?/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#has_css?/3","title":"Wallaby.Browser.has_css?/3","type":"function","doc":"Searches for CSS on the page."},{"ref":"Wallaby.Browser.html#has_no_css?/2","title":"Wallaby.Browser.has_no_css?/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#has_no_css?/3","title":"Wallaby.Browser.has_no_css?/3","type":"function","doc":"Searches for css that should not be on the page"},{"ref":"Wallaby.Browser.html#has_text?/2","title":"Wallaby.Browser.has_text?/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#has_text?/3","title":"Wallaby.Browser.has_text?/3","type":"function","doc":"Matches the Element&#39;s content with the provided text"},{"ref":"Wallaby.Browser.html#has_value?/2","title":"Wallaby.Browser.has_value?/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#has_value?/3","title":"Wallaby.Browser.has_value?/3","type":"function","doc":"Matches the Element&#39;s value with the provided value."},{"ref":"Wallaby.Browser.html#hover/2","title":"Wallaby.Browser.hover/2","type":"function","doc":"Hovers over an element."},{"ref":"Wallaby.Browser.html#maximize_window/1","title":"Wallaby.Browser.maximize_window/1","type":"function","doc":"Maximizes the currenty focused window. For most browsers, this requires a window manager to be running."},{"ref":"Wallaby.Browser.html#move_mouse_by/3","title":"Wallaby.Browser.move_mouse_by/3","type":"function","doc":"Moves mouse by an offset relative to current cursor position."},{"ref":"Wallaby.Browser.html#move_window/3","title":"Wallaby.Browser.move_window/3","type":"function","doc":"Sets the position of the currenty focused window."},{"ref":"Wallaby.Browser.html#page_source/1","title":"Wallaby.Browser.page_source/1","type":"function","doc":"Retrieves the source of the current page."},{"ref":"Wallaby.Browser.html#page_title/1","title":"Wallaby.Browser.page_title/1","type":"function","doc":"Gets the title for the current page"},{"ref":"Wallaby.Browser.html#refute_has/2","title":"Wallaby.Browser.refute_has/2","type":"macro","doc":"Checks if query is not present within parent and raises if it is found. Returns the given parent if the query is not found so that it is easily pipeable. Examples session |&gt; visit(&quot;/&quot;) |&gt; refute_has(Query.css(&quot;.secret-admin-content&quot;))"},{"ref":"Wallaby.Browser.html#resize_window/3","title":"Wallaby.Browser.resize_window/3","type":"function","doc":"Sets the size of the currenty focused window."},{"ref":"Wallaby.Browser.html#retry/2","title":"Wallaby.Browser.retry/2","type":"function","doc":"Attempts to synchronize with the browser. This is most often used to execute queries repeatedly until it either exceeds the time limit or returns a success. Note It is possible that this function never halts. Whenever we experience a stale reference error we retry the query without checking to see if we&#39;ve run over our time. In practice we should eventually be able to query the dom in a stable state. However, if this error does continue to occur it will cause wallaby to loop forever (or until the test is killed by exunit)."},{"ref":"Wallaby.Browser.html#selected?/2","title":"Wallaby.Browser.selected?/2","type":"function","doc":"Checks if the element has been selected. Alias for checked?(element)"},{"ref":"Wallaby.Browser.html#send_keys/2","title":"Wallaby.Browser.send_keys/2","type":"function","doc":""},{"ref":"Wallaby.Browser.html#send_keys/3","title":"Wallaby.Browser.send_keys/3","type":"function","doc":"Sends a list of key strokes to active element. If strings are included then they are sent as individual keys. Special keys should be provided as a list of atoms, which are automatically converted into the corresponding key codes. For a list of available key codes see Wallaby.Helpers.KeyCodes. Example iex&gt; Wallaby.Session.send_keys(session, [&quot;Example Text&quot;, :enter]) iex&gt; Wallaby.Session.send_keys(session, [:enter]) iex&gt; Wallaby.Session.send_keys(session, [:shift, :enter]) Note Currently, ChromeDriver only supports BMP Unicode characters. Emojis are SMP characters and will be ignored by ChromeDriver. Using JavaScript is a known workaround for filling in fields with Emojis and other non-BMP characters."},{"ref":"Wallaby.Browser.html#set_cookie/3","title":"Wallaby.Browser.set_cookie/3","type":"function","doc":""},{"ref":"Wallaby.Browser.html#set_value/3","title":"Wallaby.Browser.set_value/3","type":"function","doc":"Sets the value of an element. The allowed type for the value depends on the type of the element. The value may be: a string of characters for a text element :selected for a radio button, checkbox or select list option :unselected for a checkbox"},{"ref":"Wallaby.Browser.html#take_screenshot/2","title":"Wallaby.Browser.take_screenshot/2","type":"function","doc":"Takes a screenshot of the current window. Screenshots are saved to a &quot;screenshots&quot; directory in the same directory the tests are run in. Pass [{:name, &quot;some_name&quot;}] to specify the file name. Defaults to a timestamp. Pass [{:log, true}] to log the location of the screenshot to stdout. Defaults to false."},{"ref":"Wallaby.Browser.html#text/1","title":"Wallaby.Browser.text/1","type":"function","doc":""},{"ref":"Wallaby.Browser.html#text/2","title":"Wallaby.Browser.text/2","type":"function","doc":"Gets the Element&#39;s text value."},{"ref":"Wallaby.Browser.html#visible?/2","title":"Wallaby.Browser.visible?/2","type":"function","doc":"Checks if the element is visible on the page"},{"ref":"Wallaby.Browser.html#visit/2","title":"Wallaby.Browser.visit/2","type":"function","doc":"Changes the current page to the provided route. Relative paths are appended to the provided base_url. Absolute paths do not use the base_url."},{"ref":"Wallaby.Browser.html#window_handle/1","title":"Wallaby.Browser.window_handle/1","type":"function","doc":"Gets the window handle of the currently focused window."},{"ref":"Wallaby.Browser.html#window_handles/1","title":"Wallaby.Browser.window_handles/1","type":"function","doc":"Gets the window handles of all available windows."},{"ref":"Wallaby.Browser.html#window_position/1","title":"Wallaby.Browser.window_position/1","type":"function","doc":"Gets the position of the currently focused window."},{"ref":"Wallaby.Browser.html#window_size/1","title":"Wallaby.Browser.window_size/1","type":"function","doc":"Gets the size of the currently focused window."},{"ref":"Wallaby.Browser.html#t:element/0","title":"Wallaby.Browser.element/0","type":"opaque","doc":""},{"ref":"Wallaby.Browser.html#t:locator/0","title":"Wallaby.Browser.locator/0","type":"type","doc":""},{"ref":"Wallaby.Browser.html#t:opts/0","title":"Wallaby.Browser.opts/0","type":"type","doc":""},{"ref":"Wallaby.Browser.html#t:parent/0","title":"Wallaby.Browser.parent/0","type":"type","doc":""},{"ref":"Wallaby.Browser.html#t:queryable/0","title":"Wallaby.Browser.queryable/0","type":"opaque","doc":""},{"ref":"Wallaby.Browser.html#t:session/0","title":"Wallaby.Browser.session/0","type":"opaque","doc":""},{"ref":"Wallaby.Browser.html#t:sync_result/0","title":"Wallaby.Browser.sync_result/0","type":"opaque","doc":""},{"ref":"Wallaby.Browser.html#t:t/0","title":"Wallaby.Browser.t/0","type":"type","doc":""},{"ref":"Wallaby.Browser.html#t:take_screenshot_opt/0","title":"Wallaby.Browser.take_screenshot_opt/0","type":"type","doc":""},{"ref":"Wallaby.CookieError.html","title":"Wallaby.CookieError","type":"exception","doc":""},{"ref":"Wallaby.DSL.html","title":"Wallaby.DSL","type":"module","doc":"Sets up the Wallaby DSL in a module. All functions in Wallaby.Browser are now accessible without a module name and Wallaby.Browser, Wallaby.Element and Wallaby.Query are all aliased. Example defmodule MyPage do use Wallaby.DSL @name_field Query.text_field(&quot;Name&quot;) @email_field Query.text_field(&quot;email&quot;) @save_button Query.button(&quot;Save&quot;) def register(session) do session |&gt; visit(&quot;/registration.html&quot;) |&gt; fill_in(@name_field, with: &quot;Chris&quot;) |&gt; fill_in(@email_field, with: &quot;c@keathly.io&quot;) |&gt; click(@save_button) end end"},{"ref":"Wallaby.DependencyError.html","title":"Wallaby.DependencyError","type":"exception","doc":""},{"ref":"Wallaby.Element.html","title":"Wallaby.Element","type":"module","doc":"Defines an Element Struct and interactions with Elements. Typically these functions are used in conjunction with a find: page |&gt; find(Query.css(&quot;.some-element&quot;), fn(element) -&gt; Element.click(element) end) These functions can be used to create new actions specific to your application: def create_todo(todo_field, todo_text) do todo_field |&gt; Element.click() |&gt; Element.fill_in(with: todo_text) |&gt; Element.send_keys([:enter]) end Retrying Unlike Browser the actions in Element do not retry if the element becomes stale. Instead an exception will be raised."},{"ref":"Wallaby.Element.html#attr/2","title":"Wallaby.Element.attr/2","type":"function","doc":"Gets the value of the element&#39;s attribute."},{"ref":"Wallaby.Element.html#clear/1","title":"Wallaby.Element.clear/1","type":"function","doc":"Clears any value set in the element."},{"ref":"Wallaby.Element.html#click/2","title":"Wallaby.Element.click/2","type":"function","doc":"Clicks the element."},{"ref":"Wallaby.Element.html#fill_in/2","title":"Wallaby.Element.fill_in/2","type":"function","doc":"Fills in the element with the specified value."},{"ref":"Wallaby.Element.html#hover/1","title":"Wallaby.Element.hover/1","type":"function","doc":"Hovers on the element."},{"ref":"Wallaby.Element.html#selected?/1","title":"Wallaby.Element.selected?/1","type":"function","doc":"Returns a boolean based on whether or not the element is selected. Note This only really makes sense for options, checkboxes, and radio buttons. Everything else will simply return false because they have no notion of &quot;selected&quot;."},{"ref":"Wallaby.Element.html#send_keys/2","title":"Wallaby.Element.send_keys/2","type":"function","doc":"Sends keys to the element."},{"ref":"Wallaby.Element.html#set_value/2","title":"Wallaby.Element.set_value/2","type":"function","doc":"Sets the value of the element."},{"ref":"Wallaby.Element.html#text/1","title":"Wallaby.Element.text/1","type":"function","doc":"Returns the text from the element."},{"ref":"Wallaby.Element.html#value/1","title":"Wallaby.Element.value/1","type":"function","doc":"Matches the Element&#39;s value with the provided value."},{"ref":"Wallaby.Element.html#visible?/1","title":"Wallaby.Element.visible?/1","type":"function","doc":"Returns a boolean based on whether or not the element is visible."},{"ref":"Wallaby.Element.html#t:attr/0","title":"Wallaby.Element.attr/0","type":"type","doc":""},{"ref":"Wallaby.Element.html#t:keys_to_send/0","title":"Wallaby.Element.keys_to_send/0","type":"type","doc":""},{"ref":"Wallaby.Element.html#t:t/0","title":"Wallaby.Element.t/0","type":"type","doc":""},{"ref":"Wallaby.Element.html#t:value/0","title":"Wallaby.Element.value/0","type":"type","doc":""},{"ref":"Wallaby.ExpectationNotMetError.html","title":"Wallaby.ExpectationNotMetError","type":"exception","doc":""},{"ref":"Wallaby.InvalidSelectorError.html","title":"Wallaby.InvalidSelectorError","type":"exception","doc":""},{"ref":"Wallaby.JSError.html","title":"Wallaby.JSError","type":"exception","doc":""},{"ref":"Wallaby.NoBaseUrlError.html","title":"Wallaby.NoBaseUrlError","type":"exception","doc":""},{"ref":"Wallaby.Phantom.html","title":"Wallaby.Phantom","type":"module","doc":"Wallaby driver for PhantomJS. Usage Start a Wallaby Session using this driver with the following command: {:ok, session} = Wallaby.start_session() Notes This driver requires PhantomJS be installed in your path. You can install PhantomJS through NPM or your package manager of choice: $ npm install -g phantomjs-prebuilt If you need to specify a specific PhantomJS you can pass the path in the configuration: config :wallaby, phantomjs: &quot;node_modules/.bin/phantomjs&quot; You can also pass arguments to PhantomJS through the phantomjs_args config setting, e.g.: config :wallaby, phantomjs_args: &quot;--webdriver-logfile=phantomjs.log&quot;"},{"ref":"Wallaby.Phantom.html#blank_page?/1","title":"Wallaby.Phantom.blank_page?/1","type":"function","doc":""},{"ref":"Wallaby.Phantom.html#child_spec/1","title":"Wallaby.Phantom.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Wallaby.Phantom.html#close_window/1","title":"Wallaby.Phantom.close_window/1","type":"function","doc":"Invoked to close the currently focused window. Callback implementation for c:Wallaby.Driver.close_window/1."},{"ref":"Wallaby.Phantom.html#focus_frame/2","title":"Wallaby.Phantom.focus_frame/2","type":"function","doc":"Invoked to change the driver focus to specified frame. Callback implementation for c:Wallaby.Driver.focus_frame/2."},{"ref":"Wallaby.Phantom.html#focus_parent_frame/1","title":"Wallaby.Phantom.focus_parent_frame/1","type":"function","doc":"Invoked to change the driver focus to parent frame. Callback implementation for c:Wallaby.Driver.focus_parent_frame/1."},{"ref":"Wallaby.Phantom.html#focus_window/2","title":"Wallaby.Phantom.focus_window/2","type":"function","doc":"Invoked to change the driver focus to window specified by handle. Callback implementation for c:Wallaby.Driver.focus_window/2."},{"ref":"Wallaby.Phantom.html#get_window_position/1","title":"Wallaby.Phantom.get_window_position/1","type":"function","doc":"Invoked to retrieve the position of the currently focused window. Callback implementation for c:Wallaby.Driver.get_window_position/1."},{"ref":"Wallaby.Phantom.html#init/1","title":"Wallaby.Phantom.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"Wallaby.Phantom.html#log/1","title":"Wallaby.Phantom.log/1","type":"function","doc":"See Wallaby.Phantom.Driver.log/1."},{"ref":"Wallaby.Phantom.html#maximize_window/1","title":"Wallaby.Phantom.maximize_window/1","type":"function","doc":"Invoked to maximize the currently focused window. Callback implementation for c:Wallaby.Driver.maximize_window/1."},{"ref":"Wallaby.Phantom.html#parse_log/1","title":"Wallaby.Phantom.parse_log/1","type":"function","doc":"See Wallaby.Phantom.Logger.parse_log/1."},{"ref":"Wallaby.Phantom.html#set_window_position/3","title":"Wallaby.Phantom.set_window_position/3","type":"function","doc":"Invoked to set the position of the currently focused window. Callback implementation for c:Wallaby.Driver.set_window_position/3."},{"ref":"Wallaby.Phantom.html#validate/0","title":"Wallaby.Phantom.validate/0","type":"function","doc":""},{"ref":"Wallaby.Phantom.html#window_handle/1","title":"Wallaby.Phantom.window_handle/1","type":"function","doc":"Invoked to get the handle for the currently focused window. Callback implementation for c:Wallaby.Driver.window_handle/1."},{"ref":"Wallaby.Phantom.html#window_handles/1","title":"Wallaby.Phantom.window_handles/1","type":"function","doc":"Invoked to get the list of handles for all windows. Callback implementation for c:Wallaby.Driver.window_handles/1."},{"ref":"Wallaby.Query.html","title":"Wallaby.Query","type":"module","doc":"Provides the query DSL. Queries are used to locate and retrieve DOM elements from a browser (see Wallaby.Browser). You create queries like so: Query.css(&quot;.some-css&quot;) Query.xpath(&quot;.//input&quot;) Form elements There are several custom finders for locating form elements. Each of these allows finding by their name, id text, or label text. This allows for more robust querying and decouples the query from presentation selectors like css classes. Query.text_field(&quot;My Name&quot;) Query.checkbox(&quot;Checkbox&quot;) Query.select(&quot;A Fancy Select Box&quot;) Query Options All of the query operations accept the following options: :count - The number of elements that should be found (default: 1). :visible - Determines if the query should return only visible elements (default: true). :selected - Determines if the query should return only selected elements (default: :any for selected and unselected). :text - Text that should be found inside the element (default: nil). :at - The position number of the element to select if multiple elements satisfy the selection criteria. (:all for all elements) Query options can also be set via functions by the same names: Query.css(&quot;.names&quot;) |&gt; Query.visible(true) |&gt; Query.count(3) Re-using queries It is often convenient to re-use queries. The easiest way is to use module attributes: @name_field Query.text_field(&quot;User Name&quot;) @submit_button Query.button(&quot;Save&quot;) If the queries need to be dynamic then you should create a module that encapsulates the queries as functions: defmodule TodoListPage do def todo_list do Query.css(&quot;.todo-list&quot;) end def todos(count) do Query.css(&quot;.todo&quot;, count: count) end end What does my query do? Wanna check out what exactly your query will do? Look no further than Wallaby.Query.compile/1 - it takes a query and returns the css or xpath query that will be sent to the driver: iex&gt; Wallaby.Query.compile Wallaby.Query.text(&quot;my text&quot;) {:xpath, &quot;.//*[contains(normalize-space(text()), \\&quot;my text\\&quot;)]&quot;} So, whenever you&#39;re not sure whatever a specific query will do just compile it to get all the details!"},{"ref":"Wallaby.Query.html#at/2","title":"Wallaby.Query.at/2","type":"function","doc":"Updates a query&#39;s at option. Example Query.css(&quot;.names&quot;) |&gt; Query.at(3)"},{"ref":"Wallaby.Query.html#at_number/1","title":"Wallaby.Query.at_number/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#attribute/3","title":"Wallaby.Query.attribute/3","type":"function","doc":"Checks if the provided attribute, value pair is contained anywhere."},{"ref":"Wallaby.Query.html#button/2","title":"Wallaby.Query.button/2","type":"function","doc":"Looks for a button (literal button or input type button, submit, image or reset) where the provided selector is the id, name, value, alt or title of the button."},{"ref":"Wallaby.Query.html#checkbox/2","title":"Wallaby.Query.checkbox/2","type":"function","doc":"Looks for a checkbox where the provided selector is the id, name or placeholder of the checkbox itself or alternatively the id or the text of the label."},{"ref":"Wallaby.Query.html#compile/1","title":"Wallaby.Query.compile/1","type":"function","doc":"Compiles a query into css or xpath so its ready to be sent to the driver iex&gt; Wallaby.Query.compile Wallaby.Query.text(&quot;my text&quot;) {:xpath, &quot;.//*[contains(normalize-space(text()), \\&quot;my text\\&quot;)]&quot;} iex&gt; Wallaby.Query.compile Wallaby.Query.css(&quot;#some-id&quot;) {:css, &quot;#some-id&quot;}"},{"ref":"Wallaby.Query.html#count/1","title":"Wallaby.Query.count/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#count/2","title":"Wallaby.Query.count/2","type":"function","doc":"Updates a query&#39;s count option. Example Query.css(&quot;.names &gt; li&quot;) |&gt; Query.count(2)"},{"ref":"Wallaby.Query.html#css/2","title":"Wallaby.Query.css/2","type":"function","doc":"Literally queries for the css selector you provide."},{"ref":"Wallaby.Query.html#data/3","title":"Wallaby.Query.data/3","type":"function","doc":"Checks if the data attribute is contained anywhere."},{"ref":"Wallaby.Query.html#file_field/2","title":"Wallaby.Query.file_field/2","type":"function","doc":"Looks for a file input where the selector is the id or name of the file input itself or the id or text of the label."},{"ref":"Wallaby.Query.html#fillable_field/2","title":"Wallaby.Query.fillable_field/2","type":"function","doc":"Looks for a text input field where the provided selector is the id, name or placeholder of the text field itself or alternatively the id or the text of the label."},{"ref":"Wallaby.Query.html#inner_text/1","title":"Wallaby.Query.inner_text/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#link/2","title":"Wallaby.Query.link/2","type":"function","doc":"Looks for a link where the selector is the id, link text, title of the link itself or the alt of an image child node."},{"ref":"Wallaby.Query.html#matches_count?/2","title":"Wallaby.Query.matches_count?/2","type":"function","doc":""},{"ref":"Wallaby.Query.html#option/2","title":"Wallaby.Query.option/2","type":"function","doc":"Looks for an option that contains the given text."},{"ref":"Wallaby.Query.html#radio_button/2","title":"Wallaby.Query.radio_button/2","type":"function","doc":"Looks for a radio button where the provided selector is the id, name or placeholder of the radio button itself or alternatively the id or the text of the label."},{"ref":"Wallaby.Query.html#result/1","title":"Wallaby.Query.result/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#select/2","title":"Wallaby.Query.select/2","type":"function","doc":"Looks for a select box where the provided selector is the id or name of the select box itself or alternatively the id or the text of the label."},{"ref":"Wallaby.Query.html#selected/2","title":"Wallaby.Query.selected/2","type":"function","doc":"Updates a query&#39;s selected option. Examples Query.css(&quot;#select-dropdown&quot;) |&gt; Query.selected(true) Query.css(&quot;#select-dropdown&quot;) |&gt; Query.selected(false)"},{"ref":"Wallaby.Query.html#selected?/1","title":"Wallaby.Query.selected?/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#specific_element_requested/1","title":"Wallaby.Query.specific_element_requested/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#text/2","title":"Wallaby.Query.text/2","type":"function","doc":"This function can be used in one of two ways. The first is by providing a selector and possible options. This generates a query that checks if the provided text is contained anywhere. Example Query.text(&quot;Submit&quot;, count: 1) The second is by providing an existing query and a value to set as the text option. Example submit_button = Query.css(&quot;#submit-button&quot;) update_button = submit_button |&gt; Query.text(&quot;Update&quot;) create_button = submit_button |&gt; Query.text(&quot;Create&quot;)"},{"ref":"Wallaby.Query.html#text_field/2","title":"Wallaby.Query.text_field/2","type":"function","doc":"See Wallaby.Query.fillable_field/2."},{"ref":"Wallaby.Query.html#validate/1","title":"Wallaby.Query.validate/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#value/2","title":"Wallaby.Query.value/2","type":"function","doc":"Checks if the provided value is contained anywhere."},{"ref":"Wallaby.Query.html#visible/2","title":"Wallaby.Query.visible/2","type":"function","doc":"Updates a query&#39;s visibility (visible if true, hidden if false). Examples Query.css(&quot;#modal&quot;) |&gt; Query.visible(true) Query.css(&quot;#modal&quot;) |&gt; Query.visible(false)"},{"ref":"Wallaby.Query.html#visible?/1","title":"Wallaby.Query.visible?/1","type":"function","doc":""},{"ref":"Wallaby.Query.html#xpath/2","title":"Wallaby.Query.xpath/2","type":"function","doc":"Literally queries for the xpath selector you provide."},{"ref":"Wallaby.Query.html#t:attribute_key_value_pair/0","title":"Wallaby.Query.attribute_key_value_pair/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:compiled/0","title":"Wallaby.Query.compiled/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:conditions/0","title":"Wallaby.Query.conditions/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:html_validation/0","title":"Wallaby.Query.html_validation/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:method/0","title":"Wallaby.Query.method/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:opts/0","title":"Wallaby.Query.opts/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:result/0","title":"Wallaby.Query.result/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:selector/0","title":"Wallaby.Query.selector/0","type":"type","doc":""},{"ref":"Wallaby.Query.html#t:t/0","title":"Wallaby.Query.t/0","type":"type","doc":""},{"ref":"Wallaby.QueryError.html","title":"Wallaby.QueryError","type":"exception","doc":""},{"ref":"Wallaby.StaleReferenceError.html","title":"Wallaby.StaleReferenceError","type":"exception","doc":""},{"ref":"readme.html","title":"","type":"extras","doc":"Wallaby helps you test your web applications by simulating realistic user interactions. By default it runs each test case concurrently and manages browsers for you. Here&#39;s an example test for a simple Todo application: defmodule MyApp.Features.TodoTest do use MyApp.FeatureCase, async: true import Wallaby.Query, only: [css: 2, text_field: 1, button: 1] test &quot;users can create todos&quot;, %{session: session} do session |&gt; visit(&quot;/todos&quot;) |&gt; fill_in(text_field(&quot;New Todo&quot;), with: &quot;Write my first Wallaby test&quot;) |&gt; click(button(&quot;Save&quot;)) |&gt; assert_has(css(&quot;.alert&quot;, text: &quot;You created a todo&quot;)) |&gt; assert_has(css(&quot;.todo-list &gt; .todo&quot;, text: &quot;Write my first Wallaby test&quot;)) end end Because Wallaby manages multiple browsers for you, its possible to test several users interacting with a page simultaneously. defmodule MyApp.Features.MultipleUsersTest do use MyApp.FeatureCase, async: true import Wallaby.Query, only: [text_field: 1, button: 1, css: 2] @page message_path(Endpoint, :index) @message_field text_field(&quot;Share Message&quot;) @share_button button(&quot;Share&quot;) def message(msg), do: css(&quot;.messages &gt; .message&quot;, text: msg) test &quot;That users can send messages to each other&quot; do {:ok, user1} = Wallaby.start_session user1 |&gt; visit(@page) |&gt; fill_in(@message_field, with: &quot;Hello there!&quot;) |&gt; click(@share_button) {:ok, user2} = Wallaby.start_session user2 |&gt; visit(@page) |&gt; fill_in(@message_field, with: &quot;Hello yourself&quot;) |&gt; click(@share_button) user1 |&gt; assert_has(message(&quot;Hello yourself&quot;)) user2 |&gt; assert_has(message(&quot;Hello there!&quot;)) end end Read on to see what else Wallaby can do or check out the Official Documentation."},{"ref":"readme.html#setup","title":" - Setup","type":"extras","doc":"Add Wallaby to your list of dependencies in mix.exs: def deps do [{:wallaby, &quot;~&gt; 0.23.0&quot;, [runtime: false, only: :test]}] end Then ensure that Wallaby is started in your test_helper.exs: {:ok, _} = Application.ensure_all_started(:wallaby) Phoenix If you&#39;re testing a Phoenix application with Ecto 2 and a database that supports sandbox mode then you can enable concurrent testing by adding the Phoenix.Ecto.SQL.Sandbox plug to your Endpoint. It&#39;s important that this is at the top of endpoint.ex before any other plugs. # lib/endpoint.ex defmodule YourApp.Endpoint do use Phoenix.Endpoint, otp_app: :your_app if Application.get_env(:your_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox end Make sure Phoenix is set up to serve endpoints in tests and that the SQL sandbox is enabled: # config/test.exs config :your_app, YourApplication.Endpoint, server: true config :your_app, :sql_sandbox, true Then in your test_helper.exs you can provide some configuration to Wallaby. At minimum, you need to specify a :base_url, so Wallaby knows how to resolve relative paths. # test/test_helper.exs Application.put_env(:wallaby, :base_url, YourApplication.Endpoint.url) Assets Assets are not re-compiled when you run mix test. This can lead to confusion if you&#39;ve made changes in javascript or css but tests are still failing. There are two common ways to avoid this confusion. The first solution is to run brunch watch from the assets directory. This will ensure that assets get recompiled after any changes. The second solution is to add a new alias to your mix config that recompiles assets for you: def project do [ app: :my_app, version: &quot;1.0.0&quot;, aliases: aliases() ] end defp aliases, do: [ &quot;test&quot;: [ &quot;assets.compile --quiet&quot;, &quot;ecto.create --quiet&quot;, &quot;ecto.migrate&quot;, &quot;test&quot;, ], &quot;assets.compile&quot;: &amp;compile_assets/1 ] defp compile_assets(_) do Mix.shell.cmd(&quot;assets/node_modules/brunch/bin/brunch build assets/&quot;) end This method is less error prone but it will cause a delay when starting your test suite. Umbrella Apps If you&#39;re testing an umbrella application containing a Phoenix application for the web interface (MyWebApp) and a separate persistence application (MyPersistenceApp) using Ecto 2 with a database that supports sandbox mode, then you can use the same setup as above, with a few tweaks. # my_web_app/lib/endpoint.ex defmodule MyWebApp.Endpoint do use Phoenix.Endpoint, otp_app: :my_web_app if Application.get_env(:my_persistence_app, :sql_sandbox) do plug Phoenix.Ecto.SQL.Sandbox end Make sure MyWebApp is set up to serve endpoints in tests and that the SQL sandbox is enabled: # my_web_app/config/test.exs config :my_web_app, MyWebApp.Endpoint, server: true config :my_persistence_app, :sql_sandbox, true Then in MyWebApp&#39;s test_helper.exs you can provide some configuration to Wallaby. At minimum, you need to specify a :base_url, so Wallaby knows how to resolve relative paths. # my_web_app/test/test_helper.exs Application.put_env(:wallaby, :base_url, MyWebApp.Endpoint.url) You will also want to add phoenix_ecto as a dependency to MyWebApp: # my_web_app/mix.exs def deps do [ {:wallaby, &quot;~&gt; 0.23&quot;, only: :test}, {:phoenix_ecto, &quot;~&gt; 3.0&quot;, only: :test} ] end PhantomJS Wallaby requires PhantomJS. You can install PhantomJS through NPM or your package manager of choice: $ npm install -g phantomjs-prebuilt Wallaby will use whatever PhantomJS you have installed in your path. If you need to specify a specific PhantomJS you can pass the path in the configuration: config :wallaby, phantomjs: &quot;some/path/to/phantomjs&quot; You can also pass arguments to PhantomJS through the phantomjs_args config setting, e.g.: config :wallaby, phantomjs_args: &quot;--webdriver-logfile=phantomjs.log&quot; Writing tests It&#39;s easiest to add Wallaby to your test suite by creating a new case template (in case of an umbrella app, take care to adjust YourApp appropriately): defmodule YourApp.FeatureCase do use ExUnit.CaseTemplate using do quote do use Wallaby.DSL alias YourApp.Repo import Ecto import Ecto.Changeset import Ecto.Query import YourApp.Router.Helpers end end setup tags do :ok = Ecto.Adapters.SQL.Sandbox.checkout(YourApp.Repo) unless tags[:async] do Ecto.Adapters.SQL.Sandbox.mode(YourApp.Repo, {:shared, self()}) end metadata = Phoenix.Ecto.SQL.Sandbox.metadata_for(YourApp.Repo, self()) {:ok, session} = Wallaby.start_session(metadata: metadata) {:ok, session: session} end end Then you can write tests like so: defmodule YourApp.UserListTest do use YourApp.FeatureCase, async: true import Wallaby.Query, only: [css: 2] test &quot;users have names&quot;, %{session: session} do session |&gt; visit(&quot;/users&quot;) |&gt; find(css(&quot;.user&quot;, count: 3)) |&gt; List.first() |&gt; assert_has(css(&quot;.user-name&quot;, text: &quot;Chris&quot;)) end end"},{"ref":"readme.html#api","title":" - API","type":"extras","doc":"The full documentation for the DSL is in the official documentation. Queries and Actions Wallaby&#39;s API is broken into 2 concepts: Queries and Actions. Queries allow us to declaratively describe the elements that we would like to interact with and Actions allow us to use those queries to interact with the DOM. Lets say that our html looks like this: &lt;ul class=&quot;users&quot;&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Ada&lt;/span&gt; &lt;/li&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Grace&lt;/span&gt; &lt;/li&gt; &lt;li class=&quot;user&quot;&gt; &lt;span class=&quot;user-name&quot;&gt;Alan&lt;/span&gt; &lt;/li&gt; &lt;/ul&gt; If we wanted to interact with all of the users then we could write a query like so css(&quot;.user&quot;, count: 3). If we only wanted to interact with a specific user then we could write a query like this css(&quot;.user-name&quot;, count: 1, text: &quot;Ada&quot;). Now we can use those queries with some actions: session |&gt; find(css(&quot;.user&quot;, count: 3)) |&gt; List.first |&gt; assert_has(css(&quot;.user-name&quot;, count: 1, text: &quot;Ada&quot;)) There are several queries for common html elements defined in the Query module. All actions accept a query. This makes it easy to use queries we&#39;ve already defined. Actions will block until the query is either satisfied or the action times out. Blocking reduces race conditions when elements are added or removed dynamically. Navigation We can navigate directly to pages with visit: visit(session, &quot;/page.html&quot;) visit(session, user_path(Endpoint, :index, 17)) It&#39;s also possible to click links directly: click(session, link(&quot;Page 1&quot;)) Finding We can find a specific element or list of elements with find: @user_form css(&quot;.user-form&quot;) @name_field text_field(&quot;Name&quot;) @email_field text_field(&quot;Email&quot;) @save_button button(&quot;Save&quot;) find(page, @user_form, fn(form) -&gt; form |&gt; fill_in(@name_field, with: &quot;Chris&quot;) |&gt; fill_in(@email_field, with: &quot;c@keathley.io&quot;) |&gt; click(@save_button) end) Passing a callback to find will return the parent which makes it easy to chain find with other actions: page |&gt; find(css(&quot;.users&quot;), &amp; assert has?(&amp;1, css(&quot;.user&quot;, count: 3))) |&gt; click(link(&quot;Next Page&quot;)) Without the callback find returns the element. This provides a way to scope all future actions within an element. page |&gt; find(css(&quot;.user-form&quot;)) |&gt; fill_in(text_field(&quot;Name&quot;), with: &quot;Chris&quot;) |&gt; fill_in(text_field(&quot;Email&quot;), with: &quot;c@keathley.io&quot;) |&gt; click(button(&quot;Save&quot;)) Interacting with forms There are a few ways to interact with form elements on a page: fill_in(session, text_field(&quot;First Name&quot;), with: &quot;Chris&quot;) clear(session, text_field(&quot;last_name&quot;)) click(session, option(&quot;Some option&quot;)) click(session, radio_button(&quot;My Fancy Radio Button&quot;)) click(session, button(&quot;Some Button&quot;)) If you need to send specific keys to an element, you can do that with send_keys: send_keys(session, [&quot;Example&quot;, &quot;Text&quot;, :enter]) Assertions Wallaby provides custom assertions to make writing tests easier: assert_has(session, css(&quot;.signup-form&quot;)) refute_has(session, css(&quot;.alert&quot;)) has?(session, css(&quot;.user-edit-modal&quot;, visible: false)) assert_has and refute_has both take a parent element as their first argument. They return that parent, making it easy to chain them together with other actions. session |&gt; assert_has(css(&quot;.signup-form&quot;)) |&gt; fill_in(text_field(&quot;Email&quot;, with: &quot;c@keathley.io&quot;)) |&gt; click(button(&quot;Sign up&quot;)) |&gt; refute_has(css(&quot;.error&quot;)) |&gt; assert_has(css(&quot;.alert&quot;, text: &quot;Welcome!&quot;)) Window Size You can set the default window size by passing in the window_size option into Wallaby.start_session\\1. Wallaby.start_session(window_size: [width: 1280, height: 720]) You can also resize the window and get the current window size during the test. resize_window(session, 100, 100) window_size(session) Screenshots It&#39;s possible take screenshots: take_screenshot(session) All screenshots are saved to a screenshots directory in the directory that the tests were run in. If you want to customize the screenshot directory you can pass it as a config value: # config/test.exs config :wallaby, screenshot_dir: &quot;/file/path&quot; # test_helper.exs Application.put_env(:wallaby, :screenshot_dir, &quot;/file/path&quot;) Automatic screenshots You can automatically take screenshots on an error: # config/test.exs config :wallaby, screenshot_on_failure: true # test_helper.exs Application.put_env(:wallaby, :screenshot_on_failure, true)"},{"ref":"readme.html#javascript","title":" - JavaScript","type":"extras","doc":"Asynchronous code Testing asynchronous JavaScript code can expose timing issues and race conditions. We might try to interact with an element that hasn&#39;t yet appeared on the page. Elements can become stale while we&#39;re trying to interact with them. Wallaby helps solve this by blocking. Instead of manually setting timeouts we can use assert_has and some declarative queries to block until the DOM is in a good state. session |&gt; click(button(&quot;Some Async Button&quot;)) |&gt; assert_has(css(&quot;.async-result&quot;)) |&gt; click(button(&quot;Next Action&quot;)) Interacting with dialogs Wallaby provides several ways to interact with JavaScript dialogs such as window.alert, window.confirm and window.prompt. You can use one of the following functions: For window.alert use accept_alert/2 For window.confirm use accept_confirm/2 or dismiss_confirm/2 For window.prompt use accept_prompt/2-3 or dismiss_prompt/2 All of these take a function as last parameter, which must include the necessary interactions to trigger the dialog. For example: alert_message = accept_alert session, fn(session) -&gt; click(session, link(&quot;Trigger alert&quot;)) end To emulate user input for a prompt, accept_prompt takes an optional parameter: prompt_message = accept_prompt session, [with: &quot;User input&quot;], fn(session) -&gt; click(session, link(&quot;Trigger prompt&quot;)) end JavaScript logging and errors Wallaby captures both JavaScript logs and errors. Any uncaught exceptions in JavaScript will be re-thrown in Elixir. This can be disabled by specifying js_errors: false in your Wallaby config. JavaScript logs are written to :stdio by default. This can be changed to any IO device by setting the :js_logger option in your Wallaby config. For instance if you want to write all JavaScript console logs to a file you could do something like this: {:ok, file} = File.open(&quot;browser_logs.log&quot;, [:write]) Application.put_env(:wallaby, :js_logger, file) Logging can be disabled by setting :js_logger to nil."},{"ref":"readme.html#config","title":" - Config","type":"extras","doc":"Adjusting timeouts Wallaby uses hackney under the hood, so we offer a hook that allows you to control any hackney options you&#39;d like to have sent along on every request. This can be controlled with the :hackney_options setting in config.exs. config :wallaby, hackney_options: [timeout: :infinity, recv_timeout: :infinity] # Overriding a value config :wallaby, hackney_options: [timeout: 5_000] Drivers Wallaby works with phantomjs out of the box. There is also experimental support for both headless chrome and selenium. The driver can be specified by setting the driver option in the wallaby config like so: # Chrome config :wallaby, driver: Wallaby.Experimental.Chrome # Selenium config :wallaby, driver: Wallaby.Experimental.Selenium See below for more information on the experimental drivers."},{"ref":"readme.html#experimental-driver-support","title":" - Experimental Driver Support","type":"extras","doc":"Currently Wallaby provides experimental support for both headless chrome and selenium. Both of these drivers are still &quot;experimental&quot; because they don&#39;t support the full api yet and because the implementation is changing rapidly. But, if you would like to use them in your project here&#39;s what you&#39;ll need to do. Headless Chrome In order to run headless chrome you&#39;ll need to have chromedriver 2.30 and chrome 60. Previous versions of both of these tools may work, but several features will be buggy. If you want to setup chrome in a CI environment then you&#39;ll still need to install and run xvfb. This is due to a bug in chromedriver 2.30 that inhibits chromedriver from handling input text correctly. The bug should be fixed in chromedriver 2.31. If you would like to disable headless mode in chrome you can pass headless: false in your config like so: config :wallaby, chrome: [ headless: false ] Custom Chromedriver binary If chromedriver is on your PATH, then you can skip this step. Otherwise (e.g., on NPM-installed chromedriver binaries), you can override the path like so: config :wallaby, chromedriver: &quot;&lt;path/to/chromedriver&gt;&quot; Custom Chrome binary By default chromedriver will find chrome for you but if you want to test against a different version you may use this option to point to the other chrome binary. config :wallaby, chrome: [ binary: &quot;path/to/google/chrome&quot; ] Selenium To run selenium you&#39;ll need to install selenium-server-standalone and geckodriver. Once you have these tools installed you&#39;ll need to manually start selenium-server separately from your test run."},{"ref":"readme.html#contributing","title":" - Contributing","type":"extras","doc":"Wallaby is a community project. PRs and Issues are greatly welcome. To get started and setup the project, make sure you&#39;ve got Elixir 1.5+ installed and then: $ mix deps.get $ npm install -g phantomjs-prebuilt # unless you&#39;ve already got PhantomJS installed $ mix test # Make sure the tests pass! Besides running the unit tests above, it is recommended to run the driver integration tests too: # Run only phantomjs integration tests $ WALLABY_DRIVER=phantom mix test # Run all tests (unit and all drivers) $ mix test.all"}]